local string_format = string.format
local table_concat = table.concat
local table_insert = table.insert

local broker = LibStub("LibDataBroker-1.1")

local SysMon = broker:NewDataObject("Broker_SysMon")
LibStub("AceTimer-3.0"):Embed(SysMon)

SysMon.icon = "Interface\\AddOns\\Broker_SysMon\\icon.tga"

function SysMon:OnUpdate()
	if not timeSinceLastUpdate then
		timeSinceLastUpdate = 0
	end
	timeSinceLastUpdate = timeSinceLastUpdate + 1

	if justEntered then
		if timeSinceLastUpdate >= 10 then
			initialMemory = collectgarbage('count')
			currentMemory = initialMemory
			mem1 = currentMemory
			mem2 = currentMemory
			mem3 = currentMemory
			mem4 = currentMemory
			mem5 = currentMemory
			mem6 = currentMemory
			mem7 = currentMemory
			mem8 = currentMemory
			mem9 = currentMemory
			mem10 = currentMemory
			justEntered = false
		end
	else
		mem1, mem2, mem3, mem4, mem5, mem6, mem7, mem8, mem9, mem10 =
			currentMemory, mem1, mem2, mem3, mem4, mem5, mem6, mem7, mem8, mem9
		currentMemory = collectgarbage('count')
		self:Update()
	end

	if timeSinceLastUpdate >= 10 then
		timeSinceLastUpdate = nil
	end
end

local t = {}
function SysMon:Update()
	if not mem10 then
		mem10 = currentMemory
	end
	local currentRate = (currentMemory - mem10) / 10

	local framerate = floor(GetFramerate() + 0.5)
	table_insert(t, format("%d|r fps", framerate))
	local latency = select(3, GetNetStats())
	table_insert(t, format("%d|r ms", latency))
	table_insert(t, format("%.1f|r MiB", currentMemory / 1024))
	table_insert(t, format("%.1f|r KiB/s", currentRate))
	self.text = table_concat(t, " ")
	
	for i = 1, #t do
		t[i] = nil
	end
end

initialMemory = collectgarbage('count')
currentMemory = initialMemory
mem1 = currentMemory
mem2 = currentMemory
mem3 = currentMemory
mem4 = currentMemory
mem5 = currentMemory
mem6 = currentMemory
mem7 = currentMemory
mem8 = currentMemory
mem9 = currentMemory
mem10 = currentMemory
timeSinceLastUpdate = 0
justEntered = true
gcTime = time()
SysMon:ScheduleRepeatingTimer("OnUpdate", 1)

SysMon:Update()